/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cs.frameworktests.integration.greeting;

import com.cs.frameworktests.integration.greeting.ejb.GreetingManager;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import javax.ejb.EJB;
import junit.framework.Assert;
import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.Archive;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.exporter.ZipExporter;
import org.jboss.shrinkwrap.api.spec.EnterpriseArchive;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.junit.Test;
import org.junit.runner.RunWith;


@RunWith(Arquillian.class)
public class GreetingTest {
  
    @EJB
    GreetingManager manager ;
    
    @Deployment
    public static Archive createTestArchive() throws IllegalArgumentException, FileNotFoundException, IOException {
       
        // the archive for the EJB
        Package greetingPackage = GreetingTest.class.getPackage();
        JavaArchive greetingArchive = ShrinkWrap.create(JavaArchive.class, "greetingManager.jar").addPackages(true, greetingPackage);
        
        // the archive for my library that we want to test
        JavaArchive frameworkLib = ShrinkWrap.create(JavaArchive.class, "framework.jar").addPackages(true, "com/cs/framework");

        // Create an ear with the EJB and the library
        EnterpriseArchive ear = ShrinkWrap.create(EnterpriseArchive.class);
        ear.addAsModule(greetingArchive);
        ear.addAsLibraries(frameworkLib);
        
        ear.as(ZipExporter.class).exportTo(new File("target/out.ear"), true);

        return ear;
    }
   
    @Test
    public void basicTest() throws Exception {
        String userName = "Earthlings";
        Assert.assertNotNull(manager);
        Assert.assertEquals("Hello " + userName, manager.greet(userName));
    }
}